<template>
  <div class="circle-photo">
    <input
      ref="fileInput"
      type="file"
      accept="image/*"
      style="display: none;"
      @change="onFilePicked"
    />
    <div class="no-image">
      <v-img
        v-if="imageUrl && imageUrl.length"
        class="image mb-3"
        :src="imageUrl"
        aspect-ratio="1"
        max-height="160px"
      />
      <v-btn
        class="upload-image"
        dark
        small
        color="primary"
        @click="onPickFile"
        :loading="loading"
      >
        <v-icon left small>mdi-cloud-upload-outline</v-icon>Upload circle cover image</v-btn
      >
      <p v-if="!imageUrl" class="pt-2 caption">This image will be your group cover image</p>
      <v-snackbar
          v-model="imageSuccessMessage"
          color="primary"
          :timeout="6000"
          top
      >
        You uploaded your image successfully.

        <template>
          <v-btn
              dark
              text
              @click="imageSuccessMessage = false"
          >
            X
          </v-btn>
        </template>
      </v-snackbar>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import EventBus from '@/event-bus'

export default {
  name: 'ImageUpload',
  props: {
    initialImage: {
      type: String,
      default: '',
      required: false
    },
    path: {
      type: String,
      default: 'facilitators',
      required: false
    },
    type: {
      type: String,
      default: 'circle',
      required: false
    }
  },
  data() {
    return {
      imageUrl: this.initialImage,
      image: null,
      loading: false,
      imageSuccessMessage: false
    }
  },
  computed: {
    ...mapState('authentication', ['user']),
    ...mapState('app', ['stateImageUrl'])
  },
  watch: {
    stateImageUrl: {
      handler(url) {
        if (url) {
          EventBus.$emit('setCircleImageUrl', url)
        }
      }
    }
  },
  methods: {
    onPickFile() {
      this.$refs.fileInput.click()
    },
    onFilePicked(event) {
      const { files } = event.target
      const filename = files[0].name
      if (filename.lastIndexOf('.') <= 0) return

      const fileReader = new FileReader()
      fileReader.addEventListener('load', () => {
        this.imageUrl = fileReader.result
      })
      fileReader.readAsDataURL(files[0])
      this.image = files[0]
      if (this.image) {
        this.loading = true
        const data = {
          image: this.image,
          type: this.type,
          uid: this.user.uid,
          profileId: this.user.uid,
          path: 'circle'
        }
        this.$store
          .dispatch('app/uploadImage', data)
          .then(() => {
            this.imageSuccessMessage = true
            this.loading = false
          })
          .catch(() => (this.loading = false))
      }
    }
  }
}
</script>

<style lang="scss"></style>
